package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.action.LifeJDBCAction;
import com.ynet.life.base.LifeDBAccess;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.loaf.LoafTools;
import com.ynet.life.loaf.jdbc.LoafQueryFactory;
import com.ynet.life.loaf.jdbc.LoafQueryInterface;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.concurrent.atomic.AtomicInteger;

public class QueryValueToKeymap extends LifeJDBCAction {

   private static final String FIELD_SEPERATOR = "||";
   private String iCollName;
   protected String sql;
   private List key;
   private List outputFields;


   public String execute(Context e) throws GENEException {
      IndexedCollection outputIColl = (IndexedCollection)e.getDataElement(this.iCollName);
      LinkedList i = new LinkedList();
      String var16 = LoafTools.parseQuerySql(e, this.sql, i);

      try {
         LoafQueryInterface a = LoafQueryFactory.getNewQuery("", "", var16);
         Connection var17 = LifeDBAccess.getConnection(this.getDataSource());
         int ps = a.getCount(var17, i);
         Trace.logDebug("LOAF", "查询条件--->".concat(String.valueOf(a)));
         Trace.logDebug("LOAF", "输入参数--->".concat(String.valueOf(i)));
         if(ps == 0) {
            return null;
         }

         PreparedStatement var20 = null;
         ResultSet resultSet = null;
         LinkedList rmList = new LinkedList();

         try {
            resultSet = (var20 = a.getQueryStatement(var17, i)).executeQuery();
            ArrayList var18 = new ArrayList();

            int var19;
            label136:
            while(resultSet.next()) {
               var19 = 0;

               while(var19 < outputIColl.size()) {
                  boolean var21 = false;
                  KeyedCollection map = (KeyedCollection)outputIColl.get(var19);
                  int resultCount = 0;

                  while(true) {
                     if(resultCount < this.key.size()) {
                        if(!map.get(this.key.get(resultCount)).equals(resultSet.getString(resultCount + 1))) {
                           ++resultCount;
                           continue;
                        }

                        rmList.add(Integer.valueOf(var19));
                        var18.add(map);
                        var21 = true;
                     }

                     if(var21) {
                        AtomicInteger var23 = new AtomicInteger(this.key.size());
                        var19 = 0;

                        while(true) {
                           if(var19 >= this.outputFields.size()) {
                              continue label136;
                           }

                           System.out.println(resultSet.getString(var23.get()) + "===");
                           map.put(this.outputFields.get(var19), resultSet.getString(var23.get()));
                           var23.getAndIncrement();
                           ++var19;
                        }
                     }

                     ++var19;
                     break;
                  }
               }
            }

            Collections.sort(rmList, new Comparator() {
               public int compare(Integer i0, Integer i1) {
                  return -i0.intValue() + i1.intValue();
               }
            });

            for(var19 = 0; var19 < rmList.size(); ++var19) {
               int var22 = ((Integer)rmList.get(var19)).intValue();
               outputIColl.remove(var22);
            }

            var18.addAll(outputIColl);
            outputIColl.removeAll();
            outputIColl.addAll(var18);
         } catch (SQLException var13) {
            var13.printStackTrace();
            Trace.logError("LifeAction", var13.getMessage());
            throw new TranFailException("EBLN0000", var13);
         } finally {
            LifeDBAccess.cleanResources(var20, resultSet);
         }
      } catch (Exception var15) {
         var15.printStackTrace();
         Trace.logError("LifeAction", var15.getMessage());
      }

      return null;
   }

   public void setICollName(String iCollName) {
      this.iCollName = iCollName;
   }

   public void setSql(String sql) {
      this.sql = sql;
   }

   public void setOutputFields(String toke) {
      ArrayList result = new ArrayList();
      StringTokenizer toke1 = new StringTokenizer(toke, "||");

      while(toke1.hasMoreElements()) {
         String input = ((String)toke1.nextElement()).trim();
         result.add(input);
      }

      this.outputFields = result;
   }

   public void setKey(String toke) {
      ArrayList result = new ArrayList();
      StringTokenizer toke1 = new StringTokenizer(toke, "||");

      while(toke1.hasMoreElements()) {
         String input = ((String)toke1.nextElement()).trim();
         result.add(input);
      }

      this.key = result;
   }

   public static void main(String[] a) {
      LinkedList a1;
      (a1 = new LinkedList()).add(Integer.valueOf(1));
      a1.add(Integer.valueOf(11));
      a1.add(Integer.valueOf(111));
      a1.add(Integer.valueOf(11));
      a1.add(Integer.valueOf(111));
      a1.add(Integer.valueOf(122));
      Collections.sort(a1, new Comparator() {
         public int compare(Integer i0, Integer i1) {
            return i0.intValue() - i1.intValue();
         }
      });
      Iterator var1 = a1.iterator();

      while(var1.hasNext()) {
         Integer a2 = (Integer)var1.next();
         System.out.println(a2);
      }

   }
}
